﻿import mx.events.EventDispatcher;
import migurski.gis.MapRegistrationMarker;
import migurski.gis.AffineTransformer;
import migurski.gis.projections.ILinearProjection;

/*
 * -----------------------------------------------------------------
 * Copyright (c) 2005 Fluid Inc. All rights reserved.
 * -----------------------------------------------------------------
 *
 * MapContainer.as
 * 
 * @desc Wrapper class for a map on the stage. 
 * 
 * @author Darren David
 *
 * CVS Information:
 * $Id: MapContainer.as,v 1.2 2005/07/04 17:32:51 darren Exp $
 * 
 * -----------------------------------------------------------------
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * -----------------------------------------------------------------
 */
 
class fluid.MapContainer
extends MovieClip
{//}	
	//{ Properties
	private var regMark1 : MapRegistrationMarker;
	private var regMark2 : MapRegistrationMarker;
	private var regMark3 : MapRegistrationMarker;

	private var _markers : Array;
	private var _transformer : AffineTransformer;
	private var _projection : ILinearProjection;

	// EventDispatcher mixins
	public var addEventListener : Function;
	public var removeEventListener : Function;
	private var dispatchEvent : Function;
	//}
	
	//{ Constructor

	public function MapContainer()
	{
		EventDispatcher.initialize( this );
		
		this._markers = [ this.regMark1, this.regMark2, this.regMark3 ];
	}
	
	//}

	
	//{ Event Handlers
	
	private function onRelease()
	{
		var clickLoc : Object = { x : _root._xmouse, y : _root._ymouse };
		this.globalToLocal( clickLoc );
		
		var eventObj : Object =
		{
			target : this,
			type   : "click",
			clickX : clickLoc.x,
			clickY : clickLoc.y
		}
		this.dispatchEvent( eventObj );
	}
	
	//}
	
	
	//{ Accessors
	
	public function get markers() : Array { return this._markers; }

	public function get transformer() : AffineTransformer 
	{ 
		return this._transformer; 
	}
	public function set transformer( t : AffineTransformer ) : Void 
	{ 
		this._transformer = t; 
	}

	public function get projection() : ILinearProjection 
	{ 
		return this._projection; 
	}
	public function set projection( p : ILinearProjection ) : Void 
	{ 
		this._projection = p; 
	}
	//}
}