﻿/*
 * -----------------------------------------------------------------
 * Copyright (c) 2005 Michal Migurski. All rights reserved.
 * -----------------------------------------------------------------
 *
 * MapRegistrationMarker.as
 * 
 * @desc Used to calibrate the Affine transformation.
 *
 * @author Michal Migurski
 * @author Darren David
 *
 * CVS Information:
 * $Id: MapRegistrationMarker.as,v 1.6 2005/07/04 17:40:16 darren Exp $
 * 
 * -----------------------------------------------------------------
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * -----------------------------------------------------------------
 */


class migurski.gis.MapRegistrationMarker
extends MovieClip
{//}
	
	//{ Properties
	
	private var _latitude : Number;
	private var _longitude : Number;
	private var _projectedX : Number;
	private var _projectedY : Number;
	
	// Child Components
	private var _tfLabel : TextField;
	
	//}
	
	
	//{ Constructor
	
	public function MapRegistrationMarker()
	{
		this._visible = false;
	}
	
	//}

	
	//{ Public Methods
	
	public function toString() : String
	{
		return "MapRegistrationMarker[ lat/long=" + [this.latitude,this.longitude] +
									 " projected x/y=" + [this.x,this.y] +
									 " Flash _x/_y=" + [this._x,this._y] + " ]";
	}

	public function setLabel( text : String )
	{
		this._tfLabel.text = text;
	}
	
	//}

	
	//{ Accessors
	
	[Inspectable(defaultValue=0)]
	public function get latitude() : Number { return this._latitude; }
	public function set latitude( lat : Number ) : Void { this._latitude = lat; }

	[Inspectable(defaultValue=0)]
	public function get longitude() : Number { return this._longitude; }
	public function set longitude( lon : Number ) : Void { this._longitude = lon; }
	
	[Inspectable(defaultValue=0)]
	public function get x() : Number { return this._projectedX; }
	public function set x( projX : Number ) : Void { this._projectedX = projX; }
	
	[Inspectable(defaultValue=0)]
	public function get y() : Number { return this._projectedY; }
	public function set y( projY : Number ) : Void { this._projectedY = projY; }
	
	//}
}